<!DOCTYPE html>

<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<body>
    <div id="app">
        <!-- <button @click='getMembers()'>Get Members</button>
        <button @click='getMembers()'>Add Member</button> -->
        <form @submit.prevent="submitForm()">

            <p v-if="errors.length">
                <b>Please correct the following errors :</b>
            <ul>
                <li v-for="error in errors">{{error}}</li>
            </ul>
            </p>

            <label for="name">Name:</label><br>
            <input type="text" ref="name1" v-model="name" :disabled="buttonStatus === 'upload'"><br>
            <label for="address">Address:</label><br>
            <textarea ref="address" v-model="address" :disabled="buttonStatus === 'upload'"></textarea>
            <br>
            <label for="no_hp">No hp:</label><br>
            <input type="text" ref="no_hp" v-model="no_hp" :disabled="buttonStatus === 'upload'"><br><br>

            <div v-if="buttonStatus === 'submit'">
                <input type="submit" value="ADD">
            </div>
            <div v-else-if="buttonStatus === 'update'">
                <input @click='updateMember(idEditMember)' type="button" value="UPDATE">
                <input @click='clearForm()' type="button" value="CANCEL" style="margin-top:5px">
            </div>
            <div v-else-if="buttonStatus === 'upload'">
                <input type="file" name="photo" ref="photo"><br>
                <input @click='submitPhotoMember(idUploadMember)' type="button" value="UPLOAD">
                <input @click='clearForm()' type="button" value="CANCEL" style="margin-top:5px">
            </div>
        </form>
        <br><br><br><br>
        <table border=1>
            <tr>
                <td>
                    Photo profil
                </td>
                <td>
                    Nama
                </td>
                <td>
                    Alamat
                </td>
                <td>
                    No hp
                </td>
                <td>
                    Action
                </td>
            </tr>
            <tr v-for="member of members">
                <td>
                    <img width=100
                        :src=" member.photo_profile ? photoDomain + member.photo_profile : 'https://dummyimage.com/16:9x1080' "
                        alt="">
                </td>
                <td>
                    {{member.name}}
                </td>
                <td>
                    {{member.address}}
                </td>
                <td>
                    {{member.no_hp}}
                </td>
                <td>
                    <button @click="editMember(member)">edit</button>
                    <button @click="removeMember(member.id)">hapus</button>
                    <button @click="uploadPhotoMember(member)">upload photo</button>
                </td>
            </tr>
        </table>

    </div>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script src="https://unpkg.com/axios/dist/axios.min.js"></script>
    <script>
        var vm = new Vue({
            el: '#app',
            data: {
                name: "",
                address: "",
                no_hp: "",
                errors: [],
                members: [],
                photoDomain: 'http://demo-api-vue.sanbercloud.com',
                buttonStatus: "submit",
                idEditMember: null,
                idUploadMember: null
            },
            methods: {
                clearForm: function () {
                    this.name = ''
                    this.address = ''
                    this.no_hp = ''
                    this.buttonStatus = 'submit'
                    this.idEditMember = null
                },
                cancelForm: function () {
                    this.name = ''
                    this.address = ''
                    this.no_hp = ''
                    this.buttonStatus = 'submit'
                    this.idEditMember = null
                },
                validationForm: function () {
                    this.errors = []

                    if (this.name.length === 0) {
                        this.errors.push('Nama harus diisi')
                        this.$refs.name.focus()
                    }

                    if (this.address.length === 0) {
                        this.errors.push('Alamat harus diisi')
                        this.$refs.address.focus()
                    }

                    if (this.no_hp.length === 0) {
                        this.errors.push('No hp harus diisi')
                        this.$refs.no_hp.focus()
                    }
                },
                submitForm: function () {

                    this.validationForm()

                    if (this.errors.length === 0) {

                        let formData = new FormData()
                        formData.append('name', this.name)
                        formData.append('address', this.address)
                        formData.append('no_hp', this.no_hp)

                        const config = {
                            method: "post",
                            url: "http://demo-api-vue.sanbercloud.com/api/member",
                            data: formData
                        }

                        axios(config)
                            .then((response) => {

                                this.clearForm()
                                this.getMembers()
                                alert(response.data.message)
                            })
                            .catch((error) => {

                            })
                    }
                },
                getMembers: function () {

                    const config = {
                        method: "get",
                        url: "http://demo-api-vue.sanbercloud.com/api/member",
                    }

                    axios(config)
                        .then((response) => {
                            //handle success
                            this.members = response.data.members
                        })
                        .catch((error) => {
                            //handle error
                            console.log(error);
                        })
                },
                removeMember: function (id) {

                    const config = {
                        method: "post",
                        url: `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                        params: { _method: "DELETE" }
                    }

                    axios(config)
                        .then((response) => {
                            //handle success
                            this.getMembers()
                            alert(response.data.message)
                        })
                        .catch((error) => {
                            //handle error
                            console.log(error);
                        })
                },
                editMember: function (member) {

                    this.name = member.name
                    this.address = member.address
                    this.no_hp = member.no_hp
                    this.buttonStatus = 'update'
                    this.idEditMember = member.id
                },
                updateMember: function (id) {

                    this.validationForm()

                    if (this.errors.length === 0) {

                        let formData = new FormData()
                        formData.append('name', this.name)
                        formData.append('address', this.address)
                        formData.append('no_hp', this.no_hp)

                        const config = {
                            method: "post",
                            url: `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                            params: { _method: "PUT" },
                            data: formData
                        }

                        axios(config)
                            .then((response) => {

                                this.clearForm()
                                this.getMembers()
                                alert(response.data.message)
                            })
                            .catch((error) => {

                            })
                    }
                },
                uploadPhotoMember: function (member) {

                    this.name = member.name
                    this.address = member.address
                    this.no_hp = member.no_hp
                    this.buttonStatus = 'upload'
                    this.idUploadMember = member.id
                },
                submitPhotoMember: function (id) {

                    let file = this.$refs.photo.files[0]

                    let formData = new FormData
                    formData.append('photo_profile', file)

                    let config = {
                        method: "post",
                        url: `http://demo-api-vue.sanbercloud.com/api/member/${id}/upload-photo-profile`,
                        data: formData
                    }

                    axios(config)
                        .then((response) => {

                            this.clearForm()
                            this.getMembers()
                            alert(response.data.message)
                        })
                        .catch((error) => {
                            console.log(error)
                        })

                }
            },
            created() {
                this.getMembers()
            }
        })
    </script>
</body>

</html>